from rocolib.api.components import FoldedComponent
from rocolib.api.composables.graph.Face import RightTriangle as Face


class RightTriangle(FoldedComponent):

  def define(self):
    self.addParameter("l", 300, paramType="length")
    self.addParameter("w", 400, paramType="length")

    self.addEdgeInterface("l", "e0", "l")
    self.addEdgeInterface("h", "e1", None)
    self.addEdgeInterface("w", "e2", "w")
    self.addFaceInterface("face", "f")

  def assemble(self):
    dx = self.getParameter("l")
    dy = self.getParameter("w")

    self.addFace(Face("f", dx, dy))

if __name__ == "__main__":
    import sympy

    RightTriangle.test()

    # Test sympy
    r = RightTriangle()
    r.makeOutput(useDefaultParameters=False, default=False)
    g = r.getGraph()
    for f in g.faces:
        sympy.pprint(f.transform3D)
        sympy.pprint(f.get3DCoords())

